From 77ea05388924fcf2a8c9fd4a777c97e4d69f5e17 Mon Sep 17 00:00:00 2001
From: Andreas Sturmlechner <asturm@gentoo.org>
Date: Wed, 16 Jan 2019 20:52:59 +0100
Subject: [PATCH] Fix build with poppler-0.73

---
 gdal/frmts/pdf/pdfsdk_headers.h | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

diff --git a/frmts/pdf/pdfsdk_headers.h b/frmts/pdf/pdfsdk_headers.h
index 9150b0f410..574943b41f 100644
--- a/frmts/pdf/pdfsdk_headers.h
+++ b/frmts/pdf/pdfsdk_headers.h
@@ -50,7 +50,6 @@
 #pragma warning( disable : 4244 ) /* conversion from 'const int' to 'Guchar', possible loss of data */
 #endif
 
-#include <goo/gtypes.h>
 #include <goo/GooList.h>
 
 /* begin of poppler xpdf includes */
@@ -79,6 +78,10 @@
 
 /* end of poppler xpdf includes */
 
+/* poppler-0.73 compatibility */
+#define Guchar unsigned char
+#define Guint unsigned int
+
 #ifdef _MSC_VER
 #pragma warning( pop )
 #endif
-- 
2.20.1