From cbed9fc91dffba30d0f9a6a06a412a04d9cd36fa Mon Sep 17 00:00:00 2001
From: Even Rouault <even.rouault@spatialys.com>
Date: Sat, 18 Nov 2023 15:38:46 +0100
Subject: [PATCH] Fix build error with libxml2 2.12

---
 port/cpl_xml_validate.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/port/cpl_xml_validate.cpp b/port/cpl_xml_validate.cpp
index 7eb49ff40c90..29070d957b65 100644
--- a/port/cpl_xml_validate.cpp
+++ b/port/cpl_xml_validate.cpp
@@ -914,7 +914,7 @@ static void CPLLibXMLWarningErrorCallback(void *ctx, const char *msg, ...)
 
     if (strstr(pszStr, "since this namespace was already imported") == nullptr)
     {
-        xmlErrorPtr pErrorPtr = xmlGetLastError();
+        const xmlError *pErrorPtr = xmlGetLastError();
         const char *pszFilename = static_cast<char *>(ctx);
         char *pszStrDup = CPLStrdup(pszStr);
         int nLen = static_cast<int>(strlen(pszStrDup));