From 60dcddbf5fab917338caf433b3e7dca283cf9720 Mon Sep 17 00:00:00 2001
From: Even Rouault <even.rouault@spatialys.com>
Date: Thu, 4 Apr 2024 17:48:33 +0200
Subject: [PATCH] Fix build with Poppler 24.05 (unreleased yet)

---
 frmts/pdf/CMakeLists.txt | 3 +++
 1 file changed, 3 insertions(+)

diff --git a/frmts/pdf/CMakeLists.txt b/frmts/pdf/CMakeLists.txt
index 9b9a1898a730..bcb19c3aa24c 100644
--- a/frmts/pdf/CMakeLists.txt
+++ b/frmts/pdf/CMakeLists.txt
@@ -54,6 +54,9 @@ if (GDAL_USE_POPPLER)
   if ("${Poppler_VERSION_MINOR}" MATCHES "0?[0-9]+")
     string(REGEX REPLACE "0?([0-9]+)" "\\1" Poppler_VERSION_MINOR ${Poppler_VERSION_MINOR})
   endif ()
+  if (Poppler_VERSION_STRING VERSION_GREATER_EQUAL "24.05")
+    target_compile_features(gdal_PDF PRIVATE cxx_std_20)
+  endif ()
   target_compile_definitions(gdal_PDF PRIVATE -DHAVE_POPPLER -DPOPPLER_MAJOR_VERSION=${Poppler_VERSION_MAJOR}
                                               -DPOPPLER_MINOR_VERSION=${Poppler_VERSION_MINOR})
 endif ()